Overview | Package | Class | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.amazonaws.services.simpledb
Class AmazonSimpleDBAsyncClient

    java.lang.Object
      com.amazonaws.AmazonWebServiceClient
          com.amazonaws.services.simpledb.AmazonSimpleDBClient
              com.amazonaws.services.simpledb.AmazonSimpleDBAsyncClient

All Implemented Interfaces:
  AmazonSimpleDB, AmazonSimpleDBAsync

    public class AmazonSimpleDBAsyncClient

extends AmazonSimpleDBClient
implements AmazonSimpleDBAsync

Client for accessing AmazonSimpleDB. All calls made using this client are non-blocking and will immediately return a Java Future. Callers must use the Future object to determine when the service call has actually completed.

Amazon SimpleDB is a web service providing the core database functions of data indexing and querying in the cloud. By offloading the time and effort associated with building and operating a web-scale database, SimpleDB provides developers the freedom to focus on application development.

A traditional, clustered relational database requires a sizable upfront capital outlay, is complex to design, and often requires extensive and repetitive database administration. Amazon SimpleDB is dramatically simpler, requiring no schema, automatically indexing your data and providing a simple API for storage and access. This approach eliminates the administrative burden of data modeling, index maintenance, and performance tuning. Developers gain access to this functionality within Amazon's proven computing environment, are able to scale instantly, and pay only for what they use.

Visit http://aws.amazon.com/simpledb/ for more information.

Constructor Summary
`AmazonSimpleDBAsyncClient(AWSCredentials awsCredentials)` Constructs a new asynchronous client to invoke service methods on AmazonSimpleDB using the specified AWS account credentials.
`AmazonSimpleDBAsyncClient(AWSCredentials awsCredentials, ClientConfiguration clientConfiguration, ExecutorService executorService)` Constructs a new asynchronous client to invoke service methods on AmazonSimpleDB using the specified AWS account credentials, executor service, and client configuration options.
`AmazonSimpleDBAsyncClient(AWSCredentials awsCredentials, ExecutorService executorService)` Constructs a new asynchronous client to invoke service methods on AmazonSimpleDB using the specified AWS account credentials and executor service.

Method Summary
`Future<Void>` | `batchPutAttributesAsync(BatchPutAttributesRequest batchPutAttributesRequest)` The `BatchPutAttributes` operation creates or replaces attributes within one or more items.
`Future<Void>` | `createDomainAsync(CreateDomainRequest createDomainRequest)` The `CreateDomain` operation creates a new domain.
`Future<Void>` | `deleteAttributesAsync(DeleteAttributesRequest deleteAttributesRequest)` Deletes one or more attributes associated with an item.
`Future<Void>` | `deleteDomainAsync(DeleteDomainRequest deleteDomainRequest)` The `DeleteDomain` operation deletes a domain.
`Future<DomainMetadataResult>` | `domainMetadataAsync(DomainMetadataRequest domainMetadataRequest)` Returns information about the domain, including when the domain was created, the number of items and attributes in the domain, and the size of the attribute names and values.
`Future<GetAttributesResult>` | `getAttributesAsync(GetAttributesRequest getAttributesRequest)` Returns all of the attributes associated with the specified item.
`ExecutorService` | `getExecutorService()` Returns the executor service used by this async client to execute requests.
`Future<ListDomainsResult>` | `listDomainsAsync(ListDomainsRequest listDomainsRequest)` The `ListDomains` operation lists all domains associated with the Access Key ID.
`Future<Void>` | `putAttributesAsync(PutAttributesRequest putAttributesRequest)` The PutAttributes operation creates or replaces attributes in an item.
`Future<SelectResult>` | `selectAsync(SelectRequest selectRequest)` The `Select` operation returns a set of attributes for `ItemNames` that match the select expression.

Methods inherited from class com.amazonaws.services.simpledb.AmazonSimpleDBClient
`batchPutAttributes, createDomain, deleteAttributes, deleteDomain, domainMetadata, getAttributes, listDomains, listDomains, putAttributes, select`

Methods inherited from class com.amazonaws.AmazonWebServiceClient
`setEndpoint, shutdown`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface com.amazonaws.services.simpledb.AmazonSimpleDB
`batchPutAttributes, createDomain, deleteAttributes, deleteDomain, domainMetadata, getAttributes, listDomains, listDomains, putAttributes, select, setEndpoint, shutdown`

Constructor Detail

### AmazonSimpleDBAsyncClient

    public AmazonSimpleDBAsyncClient(AWSCredentials awsCredentials)

  Constructs a new asynchronous client to invoke service methods on AmazonSimpleDB using the specified AWS account credentials. Default client settings will be used, and a default cached thread pool will be created for executing the asynchronous tasks.

  All calls made using this new client object are non-blocking, and will immediately return a Java Future object that the caller can later check to see if the service call has actually completed.

  Parameters:
    `awsCredentials` - The AWS credentials (access key ID and secret key) to use when authenticating with AWS services.

### AmazonSimpleDBAsyncClient

    public AmazonSimpleDBAsyncClient(AWSCredentials awsCredentials,
                                     ExecutorService executorService)

  Constructs a new asynchronous client to invoke service methods on AmazonSimpleDB using the specified AWS account credentials and executor service. Default client settings will be used.

  All calls made using this new client object are non-blocking, and will immediately return a Java Future object that the caller can later check to see if the service call has actually completed.

  Parameters:
    `awsCredentials` - The AWS credentials (access key ID and secret key) to use when authenticating with AWS services.
    `executorService` - The executor service by which all asynchronous requests will be executed.

### AmazonSimpleDBAsyncClient

    public AmazonSimpleDBAsyncClient(AWSCredentials awsCredentials,
                                     ClientConfiguration clientConfiguration,
                                     ExecutorService executorService)

  Constructs a new asynchronous client to invoke service methods on AmazonSimpleDB using the specified AWS account credentials, executor service, and client configuration options.

  All calls made using this new client object are non-blocking, and will immediately return a Java Future object that the caller can later check to see if the service call has actually completed.

  Parameters:
    `awsCredentials` - The AWS credentials (access key ID and secret key) to use when authenticating with AWS services.
    `clientConfiguration` - Client configuration options (ex: max retry limit, proxy settings, etc).
    `executorService` - The executor service by which all asynchronous requests will be executed.

Method Detail

### getExecutorService

    public ExecutorService getExecutorService()

  Returns the executor service used by this async client to execute requests.

  Returns:
    The executor service used by this async client to execute requests.

### selectAsync

    public Future<SelectResult> selectAsync(SelectRequest selectRequest)
                                     throws AmazonServiceException,
                                            AmazonClientException

  The `Select` operation returns a set of attributes for `ItemNames` that match the select expression. `Select` is similar to the standard SQL SELECT statement.

  The total size of the response cannot exceed 1 MB in total size. Amazon SimpleDB automatically adjusts the number of items returned per page to enforce this limit. For example, if the client asks to retrieve 2500 items, but each individual item is 10 kB in size, the system returns 100 items and an appropriate `NextToken` so the client can access the next page of results.

  For information on how to construct select expressions, see Using Select to Create Amazon SimpleDB Queries in the Developer Guide.

  Specified by:
    `selectAsync` in interface `AmazonSimpleDBAsync`
  Parameters:
    `selectRequest` - Container for the necessary parameters to execute the Select operation on AmazonSimpleDB.
  Returns:
    A Java Future object containing the response from the Select service method, as returned by AmazonSimpleDB.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSimpleDB indicating either a problem with the data in the request, or a server side issue.

### putAttributesAsync

    public Future<Void> putAttributesAsync(PutAttributesRequest putAttributesRequest)
                                    throws AmazonServiceException,
                                           AmazonClientException

  The PutAttributes operation creates or replaces attributes in an item. The client may specify new attributes using a combination of the `Attribute.X.Name` and `Attribute.X.Value` parameters. The client specifies the first attribute by the parameters `Attribute.0.Name` and `Attribute.0.Value` , the second attribute by the parameters `Attribute.1.Name` and `Attribute.1.Value` , and so on.

  Attributes are uniquely identified in an item by their name/value combination. For example, a single item can have the attributes `{ "first_name", "first_value" }` and `{ "first_name", second_value" }` . However, it cannot have two attribute instances where both the `Attribute.X.Name` and `Attribute.X.Value` are the same.

  Optionally, the requestor can supply the `Replace` parameter for each individual attribute. Setting this value to `true` causes the new attribute value to replace the existing attribute value(s). For example, if an item has the attributes `{ 'a', '1' }` , `{ 'b', '2'}` and `{ 'b', '3' }` and the requestor calls `PutAttributes` using the attributes `{ 'b', '4' }` with the `Replace` parameter set to true, the final attributes of the item are changed to `{ 'a', '1' }` and `{ 'b', '4' }` , which replaces the previous values of the 'b' attribute with the new value.

  NOTE: Using PutAttributes to replace attribute values that do not exist will not result in an error response.

  You cannot specify an empty string as an attribute name.

  Because Amazon SimpleDB makes multiple copies of client data and uses an eventual consistency update model, an immediate GetAttributes or Select operation (read) immediately after a DeleteAttributes operation (write) might not return the updated data.

  The following limitations are enforced for this operation:

  - 256 total attribute name-value pairs per item
  - One billion attributes per domain
  - 10 GB of total user data storage per domain

  Specified by:
    `putAttributesAsync` in interface `AmazonSimpleDBAsync`
  Parameters:
    `putAttributesRequest` - Container for the necessary parameters to execute the PutAttributes operation on AmazonSimpleDB.
  Returns:
    A Java Future object containing the response from the PutAttributes service method, as returned by AmazonSimpleDB.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSimpleDB indicating either a problem with the data in the request, or a server side issue.

### deleteDomainAsync

    public Future<Void> deleteDomainAsync(DeleteDomainRequest deleteDomainRequest)
                                   throws AmazonServiceException,
                                          AmazonClientException

  The `DeleteDomain` operation deletes a domain. Any items (and their attributes) in the domain are deleted as well. The `DeleteDomain` operation might take 10 or more seconds to complete.

  NOTE: Running DeleteDomain on a domain that does not exist or running the function multiple times using the same domain name will not result in an error response.

  Specified by:
    `deleteDomainAsync` in interface `AmazonSimpleDBAsync`
  Parameters:
    `deleteDomainRequest` - Container for the necessary parameters to execute the DeleteDomain operation on AmazonSimpleDB.
  Returns:
    A Java Future object containing the response from the DeleteDomain service method, as returned by AmazonSimpleDB.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSimpleDB indicating either a problem with the data in the request, or a server side issue.

### createDomainAsync

    public Future<Void> createDomainAsync(CreateDomainRequest createDomainRequest)
                                   throws AmazonServiceException,
                                          AmazonClientException

  The `CreateDomain` operation creates a new domain. The domain name should be unique among the domains associated with the Access Key ID provided in the request. The `CreateDomain` operation may take 10 or more seconds to complete.

  NOTE: CreateDomain is an idempotent operation; running it multiple times using the same domain name will not result in an error response.

  The client can create up to 100 domains per account.

  If the client requires additional domains, go to http://aws.amazon.com/contact-us/simpledb-limit-request/ .

  Specified by:
    `createDomainAsync` in interface `AmazonSimpleDBAsync`
  Parameters:
    `createDomainRequest` - Container for the necessary parameters to execute the CreateDomain operation on AmazonSimpleDB.
  Returns:
    A Java Future object containing the response from the CreateDomain service method, as returned by AmazonSimpleDB.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSimpleDB indicating either a problem with the data in the request, or a server side issue.

### deleteAttributesAsync

    public Future<Void> deleteAttributesAsync(DeleteAttributesRequest deleteAttributesRequest)
                                       throws AmazonServiceException,
                                              AmazonClientException

  Deletes one or more attributes associated with an item. If all attributes of the item are deleted, the item is deleted.

  NOTE: If DeleteAttributes is called without being passed any attributes or values specified, all the attributes for the item are deleted.

  `DeleteAttributes` is an idempotent operation; running it multiple times on the same item or attribute does not result in an error response.

  Because Amazon SimpleDB makes multiple copies of item data and uses an eventual consistency update model, performing a GetAttributes or Select operation (read) immediately after a `DeleteAttributes` or PutAttributes operation (write) might not return updated item data.

  Specified by:
    `deleteAttributesAsync` in interface `AmazonSimpleDBAsync`
  Parameters:
    `deleteAttributesRequest` - Container for the necessary parameters to execute the DeleteAttributes operation on AmazonSimpleDB.
  Returns:
    A Java Future object containing the response from the DeleteAttributes service method, as returned by AmazonSimpleDB.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSimpleDB indicating either a problem with the data in the request, or a server side issue.

### listDomainsAsync

    public Future<ListDomainsResult> listDomainsAsync(ListDomainsRequest listDomainsRequest)
                                               throws AmazonServiceException,
                                                      AmazonClientException

  The `ListDomains` operation lists all domains associated with the Access Key ID. It returns domain names up to the limit set by MaxNumberOfDomains. A NextToken is returned if there are more than `MaxNumberOfDomains` domains. Calling `ListDomains` successive times with the `NextToken` provided by the operation returns up to `MaxNumberOfDomains` more domain names with each successive operation call.

  Specified by:
    `listDomainsAsync` in interface `AmazonSimpleDBAsync`
  Parameters:
    `listDomainsRequest` - Container for the necessary parameters to execute the ListDomains operation on AmazonSimpleDB.
  Returns:
    A Java Future object containing the response from the ListDomains service method, as returned by AmazonSimpleDB.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSimpleDB indicating either a problem with the data in the request, or a server side issue.

### getAttributesAsync

    public Future<GetAttributesResult> getAttributesAsync(GetAttributesRequest getAttributesRequest)
                                                   throws AmazonServiceException,
                                                          AmazonClientException

  Returns all of the attributes associated with the specified item. Optionally, the attributes returned can be limited to one or more attributes by specifying an attribute name parameter.

  If the item does not exist on the replica that was accessed for this operation, an empty set is returned. The system does not return an error as it cannot guarantee the item does not exist on other replicas.

  NOTE: If GetAttributes is called without being passed any attribute names, all the attributes for the item are returned.

  Specified by:
    `getAttributesAsync` in interface `AmazonSimpleDBAsync`
  Parameters:
    `getAttributesRequest` - Container for the necessary parameters to execute the GetAttributes operation on AmazonSimpleDB.
  Returns:
    A Java Future object containing the response from the GetAttributes service method, as returned by AmazonSimpleDB.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSimpleDB indicating either a problem with the data in the request, or a server side issue.

### batchPutAttributesAsync

    public Future<Void> batchPutAttributesAsync(BatchPutAttributesRequest batchPutAttributesRequest)
                                         throws AmazonServiceException,
                                                AmazonClientException

  The `BatchPutAttributes` operation creates or replaces attributes within one or more items. By using this operation, the client can perform multiple PutAttribute operation with a single call. This helps yield savings in round trips and latencies, enabling Amazon SimpleDB to optimize requests and generally produce better throughput.

  The client may specify the item name with the `Item.X.ItemName` parameter. The client may specify new attributes using a combination of the `Item.X.Attribute.Y.Name` and `Item.X.Attribute.Y.Value` parameters. The client may specify the first attribute for the first item using the parameters `Item.0.Attribute.0.Name` and `Item.0.Attribute.0.Value` , and for the second attribute for the first item by the parameters `Item.0.Attribute.1.Name` and `Item.0.Attribute.1.Value` , and so on.

  Attributes are uniquely identified within an item by their name/value combination. For example, a single item can have the attributes `{ "first_name", "first_value" }` and `{ "first_name", "second_value" }` . However, it cannot have two attribute instances where both the `Item.X.Attribute.Y.Name` and `Item.X.Attribute.Y.Value` are the same.

  Optionally, the requester can supply the `Replace` parameter for each individual value. Setting this value to `true` will cause the new attribute values to replace the existing attribute values. For example, if an item `I` has the attributes `{ 'a', '1' }, { 'b', '2'}` and `{ 'b', '3' }` and the requester does a BatchPutAttributes of `{'I', 'b', '4' }` with the Replace parameter set to true, the final attributes of the item will be `{ 'a', '1' }` and `{ 'b', '4' }` , replacing the previous values of the 'b' attribute with the new value.

  NOTE: You cannot specify an empty string as an item or as an attribute name. The BatchPutAttributes operation succeeds or fails in its entirety. There are no partial puts.

  IMPORTANT: This operation is vulnerable to exceeding the maximum URL size when making a REST request using the HTTP GET method. This operation does not support conditions using Expected.X.Name, Expected.X.Value, or Expected.X.Exists.

  You can execute multiple `BatchPutAttributes` operations and other operations in parallel. However, large numbers of concurrent `BatchPutAttributes` calls can result in Service Unavailable (503) responses.

  The following limitations are enforced for this operation:

  - 256 attribute name-value pairs per item
  - 1 MB request size
  - 1 billion attributes per domain
  - 10 GB of total user data storage per domain
  - 25 item limit per `BatchPutAttributes` operation

  Specified by:
    `batchPutAttributesAsync` in interface `AmazonSimpleDBAsync`
  Parameters:
    `batchPutAttributesRequest` - Container for the necessary parameters to execute the BatchPutAttributes operation on AmazonSimpleDB.
  Returns:
    A Java Future object containing the response from the BatchPutAttributes service method, as returned by AmazonSimpleDB.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSimpleDB indicating either a problem with the data in the request, or a server side issue.

### domainMetadataAsync

    public Future<DomainMetadataResult> domainMetadataAsync(DomainMetadataRequest domainMetadataRequest)
                                                     throws AmazonServiceException,
                                                            AmazonClientException

  Returns information about the domain, including when the domain was created, the number of items and attributes in the domain, and the size of the attribute names and values.

  Specified by:
    `domainMetadataAsync` in interface `AmazonSimpleDBAsync`
  Parameters:
    `domainMetadataRequest` - Container for the necessary parameters to execute the DomainMetadata operation on AmazonSimpleDB.
  Returns:
    A Java Future object containing the response from the DomainMetadata service method, as returned by AmazonSimpleDB.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSimpleDB indicating either a problem with the data in the request, or a server side issue.

Overview | Package | Class | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2010 Amazon Web Services, Inc. All Rights Reserved.